import java.io.*;
import org.xmlpull.v1.*;
import org.xmlpull.mxp1.MXParser;

public class MXP1Bench extends BenchBase {
    protected InputStream createInputStream() {
	return getClass().getResourceAsStream(filename);
    }

    protected void parse(InputStream s) throws Exception {
	XmlPullParser xpp = null;
	elementCount = 0;
	attributeCount = 0;
	characterCount = 0;
	try {
	    xpp = new MXParser();
	    xpp.setInput(s, encoding);
	    // count
	    int pos[] = new int[2];
	    int et = xpp.getEventType();
	    if(et == xpp.START_DOCUMENT) {
		et = xpp.next();
	    }
	    while (et != xpp.END_DOCUMENT) {
		if (et == xpp.START_TAG) {
		    //System.err.println(xpp.getName());
		    elementCount++;
		    attributeCount += xpp.getAttributeCount();
		} else if (et == xpp.TEXT) {
		    xpp.getTextCharacters(pos);
		    characterCount += pos[1]; // text length.
		}
		et = xpp.next();
	    }
	} finally {
	    if (s != null) {
		try {
		    s.close();
		} catch (Exception e) {}
	    }
	}
    }
}
