import java.io.*;
import org.xml.sax.*;
import uk.co.wilson.xml.MinML2;

public class MinML2Bench extends BenchBase implements ContentHandler {
    protected InputStream createInputStream() {
	return getClass().getResourceAsStream(filename);
    }

    protected void parse(InputStream s) throws Exception {
	elementCount = 0;
	attributeCount = 0;
	characterCount = 0;
	try {
	    XMLReader parser = new MinML2();
	    parser.setContentHandler(this);
	    parser.parse(new InputSource(new InputStreamReader(s, encoding)));
	} finally {
	    if (s != null) {
		try {
		    s.close();
		} catch (Exception e) {}
	    }
	}
    }

    public void characters(char[] ch, int start, int length) {
	characterCount += length;
    }
    public void startElement(String namespaceURI,
			     String localName, String qName, Attributes atts) {
	elementCount++;
	attributeCount += atts.getLength();
    }
    public void endElement(String namespaceURI,
			   String localName, String qName) {}
    public void startDocument() {}
    public void endDocument() {}
    public void ignorableWhitespace(char[] ch, int start, int length) {}
    public void processingInstruction(String target, String data) {}
    public void setDocumentLocator(Locator locator) {}

    public void startPrefixMapping(String prefix, String uri) {}
    public void endPrefixMapping(String prefix) {}

    public void skippedEntity(String name) {}
}
