import java.io.*;
import java.util.*;
import nanoxml.*;

public class NanoLiteBench extends BenchBase {
    protected InputStream createInputStream() throws Exception {
	return getClass().getResourceAsStream(filename);
    }

    protected void parse(InputStream s) throws Exception {
	XMLElement doc = null;
	elementCount = 0;
	attributeCount = 0;
	characterCount = 0;
	try {
	    doc = new XMLElement();
	    doc.parseFromReader(new InputStreamReader(s, encoding));
	    count(doc);
	} finally {
	    if (s != null) {
		try {
		    s.close();
		} catch (Exception e) {}
	    }
	}
    }

    private void count(XMLElement elm) {
	// count elements recursively
	elementCount++;
	Enumeration ae = elm.enumerateAttributeNames();
	while (ae.hasMoreElements()) {
	    attributeCount++;
	    ae.nextElement();
	}
	String content = elm.getContent();
	if (content != null) {
	    characterCount += content.length();
	}
	if (elm.countChildren() != 0) {
	    Enumeration ee = elm.enumerateChildren();
	    while (ee.hasMoreElements()) {
		count((XMLElement)ee.nextElement());
	    }
	}
    }
}
